#!/usr/bin/perl

use strict;
print "Content-type: text/html; charset=UTF-8\n\n";
print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>Time Simulator Result Page</TITLE>\n";
print "</HEAD>\n\n";
print "<BODY  BGCOLOR=#000000 TEXT=#00FF00 LINK=#00FF00 VLINK=#FFFFFF>\n";
print "<DIV ALIGN=CENTER>\n";

my ($pathinf, $qrystr)=split(/\?/, $ENV{'REQUEST_URI'});
read (STDIN, $qrystr, $ENV{'CONTENT_LENGTH'}) if($ENV{'CONTENT_LENGTH'} ne "");
my @qryval = split('&', $qrystr);
my (%param, $name, $value, $ix, $iy, $iz, $pchk);
foreach my $im (@qryval){
	($name, $value) = split('=', $im);
	$param{$name} = $value;
}
$param{'flat'} = 100 if($param{'flat'} eq "");
$param{'min'} += sprintf("%d", $param{'sec'} / 60);
$param{'sec'} = sprintf("%d", $param{'sec'} % 60);
$param{'hour'} += sprintf("%d", $param{'min'} / 60);
$param{'min'} = sprintf("%d", $param{'min'} % 60);
$pathinf=~s/$ENV{'SCRIPT_NAME'}// if($pathinf ne "");

my (%time, %pace, $thor, $tmin, $tsec, $pmin, $psec, $dstd);
print "<TABLE  border=3 cellpadding=1 cellspacing=1>\n";
my @dist = (0.4, 1, 5, 10, 21.0975, 30, 42.195);
print "<TR><TH>Distance</TH>\n";
print "<TH>Pace<BR>[/km]</TH>\n";
print "<TH>Time</TH></TR>\n";

if($param{'type'} eq "time"){ 
($thor, $tmin, $tsec) = ($param{'hour'}, $param{'min'}, $param{'sec'});
$time{$param{'dist'}} = ($thor * 3600) + ($tmin * 60) + $tsec;
$pace{$param{'dist'}} = sprintf("%d", $time{$param{'dist'}} / $param{'dist'});
if($param{'dist'}==0.4){
$pchk = $time{$param{'dist'}} / $param{'dist'} - $pace{$param{'dist'}};
$time{$param{'dist'}} += $pchk if($pchk>0);
$pace{$param{'dist'}} = sprintf("%d", $time{$param{'dist'}} / $param{'dist'});
}
else{
$pace{$param{'dist'}} = $pace{$param{'dist'}} + 1 if($time{$param{'dist'}} % $param{'dist'} != 0);
}
$pchk = 600 + (($param{'dist'} - 42.195) * $param{'gap'});
if($pace{$param{'dist'}}>$pchk){
$pace{$param{'dist'}} = $pchk;
$time{$param{'dist'}} = $pace{$param{'dist'}} * $param{'dist'};
}
$pchk = 100 + (($param{'dist'} - 0.4) * $param{'gap'});
if($pace{$param{'dist'}}<$pchk){
$pace{$param{'dist'}} = $pchk;
$time{$param{'dist'}} = $pace{$param{'dist'}} * $param{'dist'};
}
for($iy=0; $iy<=$#dist; $iy++){
$dstd=$dist[$iy] - $param{'dist'};
$dstd=$dstd - 3.4 if($iy==0 && $pace{$param{'dist'}}>$pchk);
$dstd=$dstd + 3.4 if($iy>0 && $param{'dist'}==0.4);
$pace{$dist[$iy]} = $pace{$param{'dist'}} + ($param{'gap'} * $dstd);
$pace{$dist[$iy]} = $pace{$dist[$iy-1]} if($dist[$iy] > $param{'flat'});
$pmin = sprintf("%d", $pace{$dist[$iy]} / 60);
$psec = sprintf("%02d", $pace{$dist[$iy]} % 60);
print "<TR>";
	if($dist[$iy] < 1){
	print "<TH>".($dist[$iy] * 1000)."m</TH>\n";
	}
	else{
	print "<TH>".$dist[$iy]."km</TH>\n";
	}
print "<TH>$pmin:$psec</TH>\n";
if($dist[$iy] == $param{'dist'}){
$time{$dist[$iy]} = $time{$param{'dist'}};
}
else{
$time{$dist[$iy]} = sprintf("%d", $pace{$dist[$iy]} * $dist[$iy]);
$time{$dist[$iy]} = $time{$dist[$iy]} + 1 if($pace{$dist[$iy]} * $dist[$iy] != $time{$dist[$iy]});
}
$tmin = sprintf("%d", $time{$dist[$iy]} / 60);
$thor = sprintf("%d", $tmin / 60);
$tmin = sprintf("%02d", $tmin - ($thor * 60));
$tsec = sprintf("%02d", $time{$dist[$iy]} % 60);
print "<TH>$thor:$tmin:$tsec</TH></TR>\n";
}
}

if($param{'type'} eq "pace"){ 
($pmin, $psec) = ($param{'min'}, $param{'sec'});
$pace{$param{'dist'}} = ($pmin *60) + $psec;
$pchk = 600 + ((42.195 - $param{'dist'}) * $param{'gap'});
if($pace{$param{'dist'}}>$pchk){
$pace{$param{'dist'}} = $pchk;
}
$pchk = 100 + (($param{'dist'} - 0.4) * $param{'gap'});
if($pace{$param{'dist'}}<$pchk){
$pace{$param{'dist'}} = $pchk;
}
$time{$param{'dist'}} = sprintf("%d", $pace{$param{'dist'}} * $param{'dist'});
$time{$param{'dist'}} = $time{$param{'dist'}} + 1 if($pace{$param{'dist'}} * $param{'dist'} != $time{$param{'dist'}});
for($iz=0; $iz<=$#dist; $iz++){
$dstd=$dist[$iz] - $param{'dist'};
$dstd=$dstd - 3.4 if($iz==0 && $pace{$param{'dist'}}>$pchk);
$dstd=$dstd + 3.4 if($iz>0 && $param{'dist'}==0.4);
$pace{$dist[$iz]} = $pace{$param{'dist'}} + ($param{'gap'} * $dstd);
$pace{$dist[$iz]} = $pace{$dist[$iz-1]} if($dist[$iz] > $param{'flat'});
$pmin = sprintf("%d", $pace{$dist[$iz]} / 60);
$psec = sprintf("%02d", $pace{$dist[$iz]} % 60);
print "<TR>";
	if($dist[$iz] < 1){
	print "<TH>".($dist[$iz] * 1000)."m</TH>\n";
	}
	else{
	print "<TH>".$dist[$iz]."km</TH>\n";
	}
print "<TH>$pmin:$psec</TH>\n";
if($dist[$iz] == $param{'dist'}){
$time{$dist[$iz]} = $time{$param{'dist'}};
}
else{
$time{$dist[$iz]} = sprintf("%d", $pace{$dist[$iz]} * $dist[$iz]);
$time{$dist[$iz]} = $time{$dist[$iz]} + 1 if($pace{$dist[$iz]} * $dist[$iz] != $time{$dist[$iz]});
}
$tmin = sprintf("%d", $time{$dist[$iz]} / 60);
$thor = sprintf("%d", $tmin / 60);
$tmin = sprintf("%02d", $tmin - ($thor * 60));
$tsec = sprintf("%02d", $time{$dist[$iz]} % 60);
print "<TH>$thor:$tmin:$tsec</TH></TR>\n";
}
}

print "</TABLE>\n<P>\n";
print "<FORM METHOD=\"POST\" ACTION=\"$pathinf\">\n";
print "<INPUT type=\"submit\" value=\"戻る\">\n";
print "</FORM>\n";
print "</DIV>\n";
print "</BODY>\n";
print "</HTML>\n";
exit 0;

